![VirtualFluids](docs/img/VF_logo.png)

 [![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active) [![Latest Release](https://git.rz.tu-bs.de/irmb/VirtualFluids/-/badges/release.svg)](https://git.rz.tu-bs.de/irmb/VirtualFluids/-/releases) 
[![pipeline status](https://git.rz.tu-bs.de/irmb/VirtualFluids/badges/main/pipeline.svg)](https://git.rz.tu-bs.de/irmb/VirtualFluids/-/commits/main)

VirtualFluids (VF) is a research code developed at the Institute for Computational Modeling in Civil Engineering (iRMB) at the Technical University Braunschweig. The code is a Computational Fluid Dynamics (CFD) solver based on the Lattice Boltzmann Method (LBM) for turbulent, thermal, multiphase and multicomponent flow problems as well as for multi-field problems such as Fluid-Structure-interaction. It includes distributed pre- and postprocessing capabilities for simulations with more than 100 billion degrees of freedom.

## Documentation
You can find more information about the code in the [wiki](https://git.rz.tu-bs.de/irmb/virtualfluids/-/wikis/home).
The wiki contains information about the installation, usage and development of VirtualFluids.

## License
VirtualFluids is licensed under the terms and conditions of the GNU General Public License (GPL) version 3 or - at your choice - any later.

See the file [COPYING.txt](COPYING.txt) for copying permissions. For a full list of contributors see [AUTHORS.md](AUTHORS.md). If you notice that a contributor is missing on the list, please contact us or open a merge request adding the name.

## How to cite
VirtualFluids is research software and developed at research institutions.
You can cite specific releases via Zenodo: [![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.10283049.svg)](https://doi.org/10.5281/zenodo.10283049).

## Contributing
You can find our main repository, where the development takes place [here](https://git.rz.tu-bs.de/irmb/VirtualFluids).
Contributions are highly welcome. Please review the [contribution guidelines](https://git.rz.tu-bs.de/irmb/virtualfluids/-/wikis/Contributing) before opening issues and merge requests.

If you notice any problems on your platform, please report an [issue](https://git.rz.tu-bs.de/irmb/virtualfluids/-/issues/new).

We are maintaining a [mailing list](https://lists.tu-braunschweig.de/sympa/subscribe/virtualfluids) for users of VirtualFluids. You can subscribe to the mailing list to receive news about new releases and other important information. If you have any further questions you can contact us via [email](mailto:vf-team@irmb.tu-bs.de).